#!/bin/sh

succ="n: f: x: (f @ ((n @ f) @ x))"
plus="m: n: f: x: ((n @ f) @ ((m @ f) @ x))"
mult="m: n: f: (m @ (n @ f))"
pred="n: f: x: (((n @ (g: h: (h @ (g @ f)))) @ u: x) @ u: u)"
sub="m: n: ((n @ $pred) @ m)"

zero="f: x: x"
one="f: x: (f @ x)"
two="f: x: (f @ (f @ x))"
three="f: x: (f @ (f @ (f @ x)))"
four="f: x: (f @ (f @ (f @ (f @ x))))"
five="f: x: (f @ (f @ (f @ (f @ (f @ x)))))"

false="f: s: s"
true="f: s: f"
and="p: q: ((p @ q) @ p)"
or="p: q: ((p @ p) @ q)"
not="p: a: b: ((p @ b) @ a)"
ifthenelse="p: p"
iszero="n: ((n @ x: $false) @ $true)"
leq="m: n: ($iszero @ (($sub @ m) @ n))"

pair="x: y: f: ((f @ x) @ y)"
first="p: (p @ $true)"
second="p: (p @ $false)"
nil="x: $true"
null="p: (p @ (x: y: $false))"
phi="x: (($pair @ ($second @ x)) @ ($succ @ ($second @ x)))"

y="g: (x: (g @ (x @ x)) @ x: (g @ (x @ x)))"

fact1="f: n: ((($iszero @ n) @ $one) @ \
	(($mult @ n) @ (f @ ($pred @ n))))"
fact="($y @ $fact1)"

fibo1="f: n: (((($leq @ n) @ $two) @ $one) @ \
	(($plus @ (f @ ($pred @ n))) @ \
	(f @ ($pred @ ($pred @ n)))))"
fibo="($y @ $fibo1)"
