#include "human.h"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

static void usage(const char *str)
{
	printf("Usage: %s [-hv] [-m size] expr...\n", str);
	exit(EXIT_FAILURE);
}

static void eval(const char *str, int verbose)
{
	char buff[BUFSIZ] = "";
	lambda expr = parse(str);

	if (verbose) {
		format(expr, buff, BUFSIZ);
		printf("%s\n", buff);

		while (reduce(&expr)) {
			format(expr, buff, BUFSIZ);
			printf("%s\n", buff);
		}
	} else {
		normal(&expr);
		format(expr, buff, BUFSIZ);
		printf("%s\n", buff);
	}

	clear(expr);
}

int main(int argc, char *argv[])
{
	int opt, verbose = 0, size = BUFSIZ;

	while (-1 != (opt = getopt(argc, argv, "hvm:"))) {
		if ('h' == opt)
			usage(argv[0]);
		else if ('v' == opt)
			verbose = 1;
		else if ('m' == opt)
			size = atoi(optarg);
	}

	reset(size);
	for (opt = optind; opt < argc; opt++)
		eval(argv[opt], verbose);
	reset(0);

	return 0;
}
