#include "human.h"

#include <ctype.h>
#include <stdlib.h>
#include <string.h>

lambda breakdown(char *buff, token list)
{
	char *ptr;
	token cursor;

	if ((ptr = findop(buff, '@'))) {
		lambda expr = get();

		*ptr = '\0';

		expr->func = breakdown(buff, list);
		expr->func->par = expr;

		expr->arg = breakdown(ptr + 1, list);
		expr->arg->par = expr;
		return expr;
	}

	if ((ptr = findop(buff, ':'))) {
		lambda expr = get();
		struct _token head = {expr, buff, list};

		*ptr = '\0';

		expr->func = breakdown(ptr + 1, &head);
		expr->func->par = expr;
		return expr;
	}

	if ('(' == *buff)
		return breakdown(buff + 1, list);

	ptr = buff;

	while (isalnum(*ptr))
		++ptr;

	*ptr = '\0';

	for (cursor = list; cursor; cursor = cursor->next)
		if (!strcmp(buff, cursor->name)) {
			lambda expr = get();

			expr->arg = cursor->func;
			return expr;
		}

	return get();
}
