#include "human.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int print(const lambda expr, char *buff, int len, token list)
{
	int cnt;
	char *ptr = buff;
	char *name;
	token cursor;

	if (expr->func) {
		if (expr->arg) {
			cnt = snprintf(ptr, len, "(");
			ptr += cnt, len -= cnt;
			cnt = print(expr->func, ptr, len, list);
			ptr += cnt, len -= cnt;
			cnt = snprintf(ptr, len, " @ ");
			ptr += cnt, len -= cnt;
			cnt = print(expr->arg, ptr, len, list);
			ptr += cnt, len -= cnt;
			cnt = snprintf(ptr, len, ")");
		} else {
			name = namenext(list);
			struct _token head = {expr, name, list};

			cnt = snprintf(ptr, len, "%s: ", name);
			ptr += cnt, len -= cnt;
			cnt = print(expr->func, ptr, len, &head);
			free(name);
		}
		return cnt + ptr - buff;
	}

	for (cursor = list; cursor; cursor = cursor->next)
		if (cursor->func == expr->arg)
			return snprintf(ptr, len, cursor->name);

	ptr = namenext(list);
	cnt = snprintf(buff, len, ptr);
	free(ptr);
	return cnt;
}

void format(const lambda expr, char *buff, int len)
{
	if (!expr)
		return;

	print(expr, buff, len, NULL);
}
