#include "machine.h"

#include <stdlib.h>
#include <string.h>

lambda memory, freehead;

lambda get()
{
	lambda new = freehead;

	if (!freehead)
		abort();

	freehead = freehead->copy;

	return memset(new, 0, sizeof(struct _lambda));
}

void put(lambda node)
{
	node->copy = freehead;
	freehead = node;
}

void clear(lambda expr)
{
	state st = init(expr);
	path wh;

	while ((wh = walk(&st))) {
		lambda tmp = st.expr;

		if (UP == wh) {
			if (tmp->func)
				put(tmp->func);

			if (tmp->arg)
				put(tmp->arg);
		}
	}

	put(expr);
}

void reset(int size)
{
	if (memory) {
		free(memory);
		memory = freehead = NULL;
		return;
	}

	if (size > 0) {
		memory = calloc(size, sizeof(struct _lambda));
		freehead = memory;

		while (--size)
			memory[size - 1].copy = &memory[size];
	}
}
