#ifndef _MACHINE_H
#define _MACHINE_H

typedef struct _lambda {
	struct _lambda *par, *copy, *func, *arg;
} *lambda;

typedef enum {
	END, UP, FUNC, ARG, VAR
} path;

typedef enum {
	UNRED, RED
} redex;

typedef enum {
	FORTH, BACK
} dir;

typedef struct {
	dir wh;
	lambda par, expr;
} state;

extern lambda memory, freehead;

void clear(lambda expr);
lambda copy(lambda expr);
lambda get();
state init(lambda expr);
redex isreducible(const lambda expr);
void normal(lambda *expr);
void put(lambda node);
void replace(lambda *expr, const lambda func, const lambda arg);
void reset(int size);
path walk(state *st);

#endif
