#include "machine.h"

state init(lambda expr)
{
	state st = {FORTH, expr->par, expr};

	return st;
}

path walk(state *st)
{
	lambda expr = st->expr;

	if (BACK == st->wh) {
		lambda par = expr->par;

		if (st->par == par)
			return END;

		if ((par->func == expr) && par->arg) {
			st->expr = par->arg;
			st->wh = FORTH;
			return ARG;
		}

		st->expr = par;
		return UP;
	}

	if (expr->func) {
		st->expr = expr->func;
		return FUNC;
	}

	st->wh = BACK;
	return VAR;
}
